#!/bin/bash
echo Building TeXDistPrefPane for intel...
echo Finding Xcode 4
tempfoo="$(basename $0)"
TMPDIR="$(mktemp -d /tmp/${tempfoo}.XXXXXX)" || exit 1
ls /*/Applications/Xcode.app/Contents/Info.plist|while read file
do
	plutil -convert xml1 -o "$TMPDIR/Info.plist" "$file"
	version="$(perl -e 'local $/="";while(<>){print "$1" if m/CFBundleShortVersionString.*?<string>(\d)\..*/s ;}' "$TMPDIR/Info.plist")"
	echo "$(dirname $(dirname $(dirname $(dirname "$file"))))" > "$TMPDIR/Xcode${version}"
done
if [ -f "$TMPDIR/Xcode4" ]
then
	if [ -z "$(xcodebuild -version|grep 'Xcode 4')" ]
	then
#		we do not use Xcode4 whereas we could
		echo -n "Do you want to use Xcode4 ? "
		read yorn
		if [ "<$yorn>" -eq "<y>" ]
		then
			OLD_PATH="$(xcode-select -print-path)"
			echo sudo xcode-select -switch "$(cat "$TMPDIR/Xcode4")"
			sudo xcode-select -switch "$(cat "$TMPDIR/Xcode4")"
			rm -Rf "$TMPDIR"
			if [ -z "$(xcodebuild -version|grep 'Xcode 4')" ]
			then
				echo "Bad xcode version";
				exit -1;
			fi
		fi
	fi
fi
cd "$(dirname "$0")"
action="$1"
if [ -z "$action" ]
then
	action="build"
fi
echo xcodebuild -project TeXDist.xcodeproj -target "TeXDistPrefPane Intel" clean "$action"
xcodebuild -project TeXDist.xcodeproj -target "TeXDistPrefPane Intel" clean "$action"
if ! [ -z "$OLD_PATH" ]
then
	echo sudo xcode-select -switch "$OLD_PATH"
	sudo xcode-select -switch "$OLD_PATH"
fi
echo Building TeXDistPrefPane for intel... DONE
